# coding: utf-8

"""
    ChannelEngine Channel API

    ChannelEngine API for channels  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from channelengine_channel_api_client.api_client import ApiClient


class ShipmentApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def shipment_index(self, **kwargs):  # noqa: E501
        """Get Shipments  # noqa: E501

        Gets all shipments created since the supplied date.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.shipment_index(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param datetime created_since: Deprecated, please use FromDate instead.
        :param list[str] statuses: Shipment status(es) to filter on
        :param datetime from_date: Filter on the creation date, starting from this date. This date is inclusive.
        :param datetime to_date: Filter on the creation date, until this date. This date is exclusive.
        :param list[str] channel_order_nos: Filter on the unique references (ids) as used by the channel.
        :param int page: The page to filter on. Starts at 1.
        :return: CollectionOfChannelShipmentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.shipment_index_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.shipment_index_with_http_info(**kwargs)  # noqa: E501
            return data

    def shipment_index_with_http_info(self, **kwargs):  # noqa: E501
        """Get Shipments  # noqa: E501

        Gets all shipments created since the supplied date.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.shipment_index_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param datetime created_since: Deprecated, please use FromDate instead.
        :param list[str] statuses: Shipment status(es) to filter on
        :param datetime from_date: Filter on the creation date, starting from this date. This date is inclusive.
        :param datetime to_date: Filter on the creation date, until this date. This date is exclusive.
        :param list[str] channel_order_nos: Filter on the unique references (ids) as used by the channel.
        :param int page: The page to filter on. Starts at 1.
        :return: CollectionOfChannelShipmentResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['created_since', 'statuses', 'from_date', 'to_date', 'channel_order_nos', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method shipment_index" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'created_since' in params:
            query_params.append(('createdSince', params['created_since']))  # noqa: E501
        if 'statuses' in params:
            query_params.append(('statuses', params['statuses']))  # noqa: E501
            collection_formats['statuses'] = 'multi'  # noqa: E501
        if 'from_date' in params:
            query_params.append(('fromDate', params['from_date']))  # noqa: E501
        if 'to_date' in params:
            query_params.append(('toDate', params['to_date']))  # noqa: E501
        if 'channel_order_nos' in params:
            query_params.append(('channelOrderNos', params['channel_order_nos']))  # noqa: E501
            collection_formats['channelOrderNos'] = 'multi'  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/shipments', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CollectionOfChannelShipmentResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
