# coding: utf-8

"""
    ChannelEngine Channel API

    ChannelEngine API for channels  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from channelengine_channel_api_client.models.channel_shipment_line_response import ChannelShipmentLineResponse  # noqa: F401,E501


class ChannelShipmentResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'channel_order_no': 'str',
        'lines': 'list[ChannelShipmentLineResponse]',
        'created_at': 'datetime',
        'updated_at': 'datetime',
        'track_trace_no': 'str',
        'track_trace_url': 'str',
        'method': 'str'
    }

    attribute_map = {
        'channel_order_no': 'ChannelOrderNo',
        'lines': 'Lines',
        'created_at': 'CreatedAt',
        'updated_at': 'UpdatedAt',
        'track_trace_no': 'TrackTraceNo',
        'track_trace_url': 'TrackTraceUrl',
        'method': 'Method'
    }

    def __init__(self, channel_order_no=None, lines=None, created_at=None, updated_at=None, track_trace_no=None, track_trace_url=None, method=None):  # noqa: E501
        """ChannelShipmentResponse - a model defined in Swagger"""  # noqa: E501

        self._channel_order_no = None
        self._lines = None
        self._created_at = None
        self._updated_at = None
        self._track_trace_no = None
        self._track_trace_url = None
        self._method = None
        self.discriminator = None

        self.channel_order_no = channel_order_no
        self.lines = lines
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if track_trace_no is not None:
            self.track_trace_no = track_trace_no
        if track_trace_url is not None:
            self.track_trace_url = track_trace_url
        if method is not None:
            self.method = method

    @property
    def channel_order_no(self):
        """Gets the channel_order_no of this ChannelShipmentResponse.  # noqa: E501

        The unique order reference used by the Channel  # noqa: E501

        :return: The channel_order_no of this ChannelShipmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._channel_order_no

    @channel_order_no.setter
    def channel_order_no(self, channel_order_no):
        """Sets the channel_order_no of this ChannelShipmentResponse.

        The unique order reference used by the Channel  # noqa: E501

        :param channel_order_no: The channel_order_no of this ChannelShipmentResponse.  # noqa: E501
        :type: str
        """
        if channel_order_no is None:
            raise ValueError("Invalid value for `channel_order_no`, must not be `None`")  # noqa: E501

        self._channel_order_no = channel_order_no

    @property
    def lines(self):
        """Gets the lines of this ChannelShipmentResponse.  # noqa: E501


        :return: The lines of this ChannelShipmentResponse.  # noqa: E501
        :rtype: list[ChannelShipmentLineResponse]
        """
        return self._lines

    @lines.setter
    def lines(self, lines):
        """Sets the lines of this ChannelShipmentResponse.


        :param lines: The lines of this ChannelShipmentResponse.  # noqa: E501
        :type: list[ChannelShipmentLineResponse]
        """
        if lines is None:
            raise ValueError("Invalid value for `lines`, must not be `None`")  # noqa: E501

        self._lines = lines

    @property
    def created_at(self):
        """Gets the created_at of this ChannelShipmentResponse.  # noqa: E501

        The date at which the shipment was created in ChannelEngine  # noqa: E501

        :return: The created_at of this ChannelShipmentResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ChannelShipmentResponse.

        The date at which the shipment was created in ChannelEngine  # noqa: E501

        :param created_at: The created_at of this ChannelShipmentResponse.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this ChannelShipmentResponse.  # noqa: E501

        The date at which the shipment was last modified in ChannelEngine  # noqa: E501

        :return: The updated_at of this ChannelShipmentResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this ChannelShipmentResponse.

        The date at which the shipment was last modified in ChannelEngine  # noqa: E501

        :param updated_at: The updated_at of this ChannelShipmentResponse.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def track_trace_no(self):
        """Gets the track_trace_no of this ChannelShipmentResponse.  # noqa: E501

        The unique shipping reference used by the Shipping carrier (track&amp;trace number)  # noqa: E501

        :return: The track_trace_no of this ChannelShipmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._track_trace_no

    @track_trace_no.setter
    def track_trace_no(self, track_trace_no):
        """Sets the track_trace_no of this ChannelShipmentResponse.

        The unique shipping reference used by the Shipping carrier (track&amp;trace number)  # noqa: E501

        :param track_trace_no: The track_trace_no of this ChannelShipmentResponse.  # noqa: E501
        :type: str
        """
        if track_trace_no is not None and len(track_trace_no) > 50:
            raise ValueError("Invalid value for `track_trace_no`, length must be less than or equal to `50`")  # noqa: E501
        if track_trace_no is not None and len(track_trace_no) < 0:
            raise ValueError("Invalid value for `track_trace_no`, length must be greater than or equal to `0`")  # noqa: E501

        self._track_trace_no = track_trace_no

    @property
    def track_trace_url(self):
        """Gets the track_trace_url of this ChannelShipmentResponse.  # noqa: E501

        A link to a page of the carrier where the customer can track the shipping of her package.  # noqa: E501

        :return: The track_trace_url of this ChannelShipmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._track_trace_url

    @track_trace_url.setter
    def track_trace_url(self, track_trace_url):
        """Sets the track_trace_url of this ChannelShipmentResponse.

        A link to a page of the carrier where the customer can track the shipping of her package.  # noqa: E501

        :param track_trace_url: The track_trace_url of this ChannelShipmentResponse.  # noqa: E501
        :type: str
        """
        if track_trace_url is not None and len(track_trace_url) > 250:
            raise ValueError("Invalid value for `track_trace_url`, length must be less than or equal to `250`")  # noqa: E501
        if track_trace_url is not None and len(track_trace_url) < 0:
            raise ValueError("Invalid value for `track_trace_url`, length must be greater than or equal to `0`")  # noqa: E501

        self._track_trace_url = track_trace_url

    @property
    def method(self):
        """Gets the method of this ChannelShipmentResponse.  # noqa: E501

        Shipment method: the carrier used for shipping the package. E.g. DHL, postNL  # noqa: E501

        :return: The method of this ChannelShipmentResponse.  # noqa: E501
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """Sets the method of this ChannelShipmentResponse.

        Shipment method: the carrier used for shipping the package. E.g. DHL, postNL  # noqa: E501

        :param method: The method of this ChannelShipmentResponse.  # noqa: E501
        :type: str
        """
        if method is not None and len(method) > 50:
            raise ValueError("Invalid value for `method`, length must be less than or equal to `50`")  # noqa: E501
        if method is not None and len(method) < 0:
            raise ValueError("Invalid value for `method`, length must be greater than or equal to `0`")  # noqa: E501

        self._method = method

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ChannelShipmentResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChannelShipmentResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
